<!DOCTYPE html>
<html>
    <head>
        <!-- Required styles for MDC Web -->
        <link href="https://fonts.googleapis.com/css?family=Noto+Sans&display=swap" rel="stylesheet">
        <link rel="stylesheet" href="https://unpkg.com/material-components-web@5.1.0/dist/material-components-web.min.css">       
        <link rel="stylesheet" href="style.css">  
    </head>
<body>
    <form id="trial_form" action="/action_page.php">   
        <div id="elg-messages"></div>
        <div class="mdc-layout-grid">
            <div class="mdc-layout-grid__inner">
            <div class="mdc-layout-grid__cell mdc-layout-grid__cell--span-10">    
                <div class="mdc-text-field mdc-text-field--textarea" data-mdc-auto-init="MDCTextField" style="width:100%">
                    <textarea id="text-to-speak" class="mdc-text-field__input" rows="3" cols="30"></textarea>
                    <div class="mdc-notched-outline">
                        <div class="mdc-notched-outline__leading"></div>
                        <div class="mdc-notched-outline__notch">
                            <label for="text-to-speak" class="mdc-floating-label">Type text to speak</label>
                        </div>
                        <div class="mdc-notched-outline__trailing"></div>
                    </div>
                </div>
            </div>
        </div>
    </div>

        <div class="mdc-layout-grid">
            <div class="mdc-layout-grid__inner">
            <div class="mdc-layout-grid__cell mdc-layout-grid__cell--span-8"> 
                <button id="submit-form" class="mdc-button mdc-button--raised next">
                    <span class="mdc-button__label">
                            Submit
                    </span>
                </button>
            </div>  
            </div>  
        </div>
        <div class="mdc-layout-grid" id="loading">
            <div class="mdc-layout-grid__inner">
            <div class="mdc-layout-grid__cell mdc-layout-grid__cell--span-10">
                <h3 class="mdc-typography--subtitle2" id="process-state">&nbsp;</h3>
                <div role="progressbar" class="mdc-linear-progress mdc-linear-progress--closed" id="submitprogress" data-mdc-auto-init="MDCLinearProgress">
                    <div class="mdc-linear-progress__buffering-dots"></div>
                    <div class="mdc-linear-progress__buffer"></div>
                    <div class="mdc-linear-progress__bar mdc-linear-progress__primary-bar">
                        <span class="mdc-linear-progress__bar-inner"></span>
                    </div>
                    <div class="mdc-linear-progress__bar mdc-linear-progress__secondary-bar">
                        <span class="mdc-linear-progress__bar-inner"></span>
                    </div>
                </div>
            </div>
            </div>
        </div>
        <div class="mdc-layout-grid" id="result">
            <div class="mdc-layout-grid__inner">
            <div class="mdc-layout-grid__cell mdc-layout-grid__cell--span-6"> 
                <audio controls class="audio-player" id="audio-player" src="" style="width:100%;">
                    Your browser does not support the
                    <code>audio</code> element.
            </audio>  
            </div>      
         </div>    
        </div>  
    </form>
<script src="https://code.jquery.com/jquery-3.4.1.js"></script>
<!-- Required MDC Web JavaScript library -->
<script src="https://unpkg.com/material-components-web@5.1.0/dist/material-components-web.min.js"></script>    
<script>
$(function() {
    //start Material framwork
    mdc.autoInit();
    var this_ = this;
    this.injectedCss = false;
    var serviceInfo;
    var i18nUrl;

    var submitprogress = document.getElementById('submitprogress').MDCLinearProgress;
    var source = document.getElementById('audio-player');
  // serviceInfo=JSON.parse(JSON.stringify({"StyleCss":"empty.css","ServiceUrl":"https://dev.european-language-grid.eu/dev/rest/async/processText/srv-tts-tilde-lv-woman"}));
    
    // Listen to messages from parent window
    window.addEventListener('message', function(e) {
        
         if((window.location.origin === e.origin) && e.data != ''){
           
             serviceInfo = JSON.parse(e.data);  
            //calling function to add theme css from ELG platform           
            addCssToDocument(serviceInfo.StyleCss);
            if (serviceInfo.ServiceUrl.indexOf('async/') >= 0) {
                i18nUrl = new URL('../../../i18n/resolve', serviceInfo.ServiceUrl);
            } else {
                i18nUrl = new URL('../../i18n/resolve', serviceInfo.ServiceUrl);
            }
        } 
    });

    //posting data to TTS service
    $("#submit-form").on("click", function(e){
        $('#elg-messages').empty();
        $("#result").hide();
        $("#loading").show();
        $("#trial_form :input").prop("disabled", true);
        e.preventDefault();              
        source.src="";
        let text = $("#text-to-speak").val();
        let url = serviceInfo.ServiceUrl;
        postData(url , text, serviceInfo.Authorization)
            .then(resp => resp.json())
            .then(data => {              
                if(data.response && data.response.type == 'stored') {                     
                        // async response, start polling                        
                        submitprogress.open();
                        submitprogress.determinate = false;
                        submitprogress.progress = 0;
                        $('#process-state').text('Processing');
                        pollForResult(data.response.uri, serviceInfo.Authorization);
                    } else {
                        // sync response, handle it now                      
                        handleResponse(data);
                 }                  
            })
            .catch(error => console.error('Error:', error));
    });

    function pollForResult(pollUrl, token) {         
            function doPoll() {
                $.get({
                    url: pollUrl,
                    headers: {'Authorization': token},
                    xhrFields: {withCredentials: true},
                    success: function (data, textStatus) {                        
                        if (data.progress) {
                            submitprogress.determinate = (data.progress.percent > 0);
                            submitprogress.progress = data.progress.percent;
                            // schedule the next poll
                            setTimeout(doPoll, 2000);
                        } else {
                            handleResponse(data);
                        }

                        return false;
                    },
                    error: elgCallError
                });
            }

            setTimeout(doPoll, 2000);
        }

    function postData(url = '', text, token) {
  // Default options are marked with *       
        return fetch(url, {
            method: 'POST', 
          //  mode: 'no-cors',
            cache: 'no-cache', 
            credentials: 'same-origin', // include, *same-origin, omit
            headers: new Headers({
                'Content-Type': 'text/plain',
                'Authorization': token
            }),
            //xhrFields:{withCredentials: true},
            redirect: 'follow', // manual, *follow, error
            referrer: 'ELG', // no-referrer, *client
            body: text, // body data type must match "Content-Type" header
        }); // parses JSON response into native JavaScript objects 
    }

    function elgCallError(jqXHR, textStatus, errorThrown) {
            var errors = [];
            var responseJSON = jqXHR.responseJSON;
            submitprogress.close();
            $("#loading").hide();
            $("#trial_form :input").prop("disabled", false);
            var msgsContainer = $('#elg-messages');
            if(responseJSON && responseJSON.hasOwnProperty("failure")) {
                errors = responseJSON.failure.errors;
                resolveErrors(errors).then(function(data) {
                    $.each(data, function(i, msg) {
                      console.log(msg);
                      msgsContainer.append($('<div class="alert alert-warning mdc-typography--body1"></div>').text(msg));
                    });
                });
            } else {
                // this should be i18n'd too really
                console.log("Unknown error occurred</div>");
                // re-enable the button
              
            }
        }

        function localResolveErrors(errors) {
            var placeholder = /{(\d+)}/g;
            var resolvedErrors = $.map(errors, function (e) {
                return e.text.replace(placeholder, function (match, num) {
                    return e.params[parseInt(num, 10)]
                });
            });
            return $.Deferred().resolve(resolvedErrors);
        }

        function resolveErrors(errors) {
            if (i18nUrl) {
                return $.post({
                    url: i18nUrl.href,
                    data: JSON.stringify(errors),
                    dataType: 'json',
                    contentType: 'application/json',
                }).fail(function (xhr, status, errorThrown) {
                    console.log(errorThrown);
                    return localResolveErrors(errors);
                });
            } else {
                return localResolveErrors(errors);
            }
        }

    function handleResponse(data) {       
        if (data.response.content) {
            const blobUrl = window.URL || window.webkitURL;
            let mimeType = "audio/mp3";
            let fileExt = ".mp3";
            if(data.response.hasOwnProperty('format') && data.response.format === 'LINEAR16') {
              mimeType = "audio/x-wav";
              fileExt = ".wav";
            }
            const url = "data:"+mimeType+";base64,"+data.response.content;
            const a = document.createElement('a');
            a.style.display = 'none';
            a.href = url;
            a.download = 'tts-output'+fileExt;
            document.body.appendChild(a);  
            source.src = url;        
        }
           submitprogress.close();
           //$('#process-state').text('Done');
            $("#result").show();
            $("#loading").hide();
            $("#trial_form :input").prop("disabled", false);
        }

    // function that adds theme css from ELG platform
    let addCssToDocument = function(Uri){
        if (!this_.injectedCss) {
                        // inject CSS
                        var elgCss = $('<link type="text/css" rel="stylesheet" media="screen,print">');
                        elgCss.attr('href', Uri);
                        $('head').append(elgCss);
                        this_.injectedCss = true;
                    }
    }

    window.parent.postMessage("GUI:Ready to receive config", window.location.origin);
    // A way how to send info to ELG platform.
    // $("#send-button").on("click", function(e){
    //     e.preventDefault();
    //     window.parent.postMessage("Message from iframe", '');
    // });

});


</script>
</body>
</html>
